﻿using Syncfusion.ListView.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using Xamarin.Forms;

namespace CustomSelection
{
    public partial class MainPage : ContentPage
    {
        #region Fields

        public SelectionViewModel ViewModel { get; set; }

        #endregion

        #region Constructor

        public MainPage()
        {
            InitializeComponent();
            ViewModel = new SelectionViewModel();
            listView.BindingContext = ViewModel;
            listView.ItemsSource = ViewModel.MusicInfo;
        }

        #endregion

        #region CallBacks

        private void ListView_OnSelectionChanged(object sender, ItemSelectionChangedEventArgs e)
        {
            for (int i = 0; i < e.AddedItems.Count; i++)
            {
                var item = e.AddedItems[i];
                (item as MusicInfo).IsSelected = true;
            }
            for (int i = 0; i < e.RemovedItems.Count; i++)
            {
                var item = e.RemovedItems[i];
                (item as MusicInfo).IsSelected = false;
            }
        }

        #endregion
    }
}
